#include "includes.h"

BITS_DESCRIPTION  bits[BITS_MAXIMUM];

FIFO inputs_ev;



void discrete_task( void)
{
int bit,flag;
int bit_state;
int i;
unsigned long long all_bits = 0;
unsigned long longtmp;

unsigned long long lltmp;

static int cnt = 0;
  get_inputs64();
  for(i=0;i<BITS_MAXIMUM;i++)
  {

   if(bits[i].flag & FLAG_ENABLED)
   {

      //if(bits[i].port->DATA & (1<<bits[i].pin))
      //  bit_state = 1;
      //else
      //	bit_state = 0;
	  bit_state = get_inputs64_bit(bits[i].pin);



      flag = bits[i].flag;
      bit = (flag & FLAG_INVERTED) ^ bit_state;
      if(bit)
      {
         if(bits[i].counter < bits[i].max)
         {
           if(++(bits[i].counter) >= bits[i].max)
           {
             if(bits[i].signal == 0)
             {
            	//front
 	            if(bits[i].mode == ENCODER_A)
 	            {
	            	  if(bits[i+1].signal)
	            	  {
	                	fifo_push(&inputs_ev,i | 0x20000000);
	            	  } else
	            	  {
	                	fifo_push(&inputs_ev, (i + 1) | 0x20000000);
	            	  }
 	            }
 	            else if(bits[i].mode != ENCODER_B)
 	            {
 	            	 fifo_push(&inputs_ev,i | 0x80000000);
				}
             }
             bits[i].signal = 1;
           }
         }
      } else
      {
        if(bits[i].counter > 0)
        {
           if(--(bits[i].counter) <= 0)
           {
             if(bits[i].signal)
             {
               // edge
  	            if(bits[i].mode == TOGGLE_SWITCH)
  	            {
  	            	fifo_push(&inputs_ev,i | 0x40000000);
  	            }

             }
	         bits[i].signal = 0;
           }
        }
      }
   }

        lltmp = bits[i].signal;
        all_bits |= (lltmp << i);
  }

  if(++cnt == 100)
  {

	 longtmp = (all_bits >> 24) & 0xFF;
	 longtmp <<= 8;
	 longtmp += (all_bits >> 40) & 0xFF;

	 lltmp = 1;
	 if(all_bits & (lltmp << 23))
	 longtmp |= (1<<16);

	 lltmp = 1;
	 if(all_bits & (lltmp << 32))
	 longtmp |= (1<<17);

	 cnt = 0;
     //longtmp = all_bits & 0x00FFFFFF;
     fifo_push(&inputs_ev,longtmp);
     //longtmp = ((all_bits >> 24) & 0x00FFFFFF) | 0x01000000;
     //fifo_push(&inputs_ev,longtmp);
     //longtmp = ((all_bits >> 48) & 0x0000FFFF) | 0x02000000;
     //fifo_push(&inputs_ev,longtmp);
  }

}


void bits_init(void)
{
int i;
for(i=0;i<64;i++)
{
  input_init(i,NULL,i,TOGGLE_SWITCH);
}


  input_init_fast(0,NULL,0,ENCODER_A);
  input_init_fast(1,NULL,1,ENCODER_B);

  input_init_fast(56,NULL,56,ENCODER_A);
  input_init_fast(57,NULL,57,ENCODER_B);

  for(i=24;i<32;i++)
  {
    input_init(i,NULL,i,ROTARY_SWITCH_POLE);
  }

  for(i=40;i<48;i++)
  {
    input_init(i,NULL,i,ROTARY_SWITCH_POLE);
  }

   init_fifo(&inputs_ev, 8);

}

typedef struct
{
 LPC_GPIO_TypeDef   *port;
 unsigned long      mask;
} LED_STRUCT;

const LED_STRUCT leds[] = {

  {  LPC_GPIO3,(0x1<<0)  /*9*/ },
  {  LPC_GPIO1,(0x1<<0)  /*7*/ },
  {  LPC_GPIO1,(0x1<<1)  /*6*/ },
  {  LPC_GPIO1,(0x1<<2)  /*8*/ },
  {  LPC_GPIO0,(0x1<<11) /*4*/ },
  {  LPC_GPIO2,(0x1<<10) /*3*/ },
  {  LPC_GPIO0,(0x1<<8)  /*2*/ },
  {  LPC_GPIO2,(0x1<<9)  /*1*/ },
  {  LPC_GPIO2,(0x1<<2)  /*0*/ },
  {  LPC_GPIO1,(0x1<<10) /*5*/ },
  {  LPC_GPIO1,(0x1<<4)  /*19*/ },
  {  LPC_GPIO1,(0x1<<11) /*18*/ },
  {  LPC_GPIO3,(0x1<<2)  /*17*/ },
  {  LPC_GPIO1,(0x1<<5)  /*16*/ },

  {  LPC_GPIO1,(0x1<<6)  /*15*/ },
  {  LPC_GPIO1,(0x1<<7)  /*14*/ },

  {  LPC_GPIO3,(0x1<<3)  /*13*/ },
  {  LPC_GPIO2,(0x1<<6)  /*12*/ },
  {  LPC_GPIO2,(0x1<<0)  /*11*/ },
  {  LPC_GPIO3,(0x1<<1) /*10*/ },

  {  LPC_GPIO2,(0x1<<3) /*lcd backlight*/ }

};

void leds_init(void)
{
  LPC_GPIO2->DIR |= (0x1<<3);
  LPC_GPIO2->DATA &= ~(0x1<<3);

int i;
    for(i=0;i<21;i++)
    {
      leds[i].port->DIR |= leds[i].mask;
      leds[i].port->DATA |= leds[i].mask;
    }

}

void led_control(int led, int state)
{
	   if(led>=0 && led <21)
	   {
	      if(state)
	        leds[led].port->DATA &= ~leds[led].mask;
	      else
	        leds[led].port->DATA |= leds[led].mask;
	   }
}




