#include "includes.h"


void bits_processing(char *buf)
{
unsigned long tmp = hex2ulong(buf);
int i;
       for(i=0;i<32;i++)
      {
    	led_control(i, tmp & (1<<i));
      }
}


int main(void)
{
char buf[20],*p;
int len;
unsigned long tmp;
	gpio_init();
    bits_init();

   // LPC_GPIO1->DIR |= (1<<5); // Avionics powered up/down bit (to feed LCD back light)

	init_timer16(0, 24000);
	enable_timer16(0);

	USBIOClkConfig();
    CDC_Init();
    USB_Init();
    USB_Connect(1);
    INIT_LCD_PINS();
	lcd_init_1();
	lcd_init_2();
	//lcd_test_pins_1();
	leds_init();

	lcd_puts(0,0, " -=FlyingCat=-  ");
	lcd_puts(0,1, "RadioStack Panel");

	lcd_puts(1,0, " -=FlyingCat=-  ");
	lcd_puts(1,1, "AutoPilot  Panel");


	restart_timer_100ms();

	while(1)
    {

		if(is_timer_100ms_zero())
		{
			restart_timer_100ms();

		     if(fifo_pop(&inputs_ev, &tmp))
		     {
			     p = buf;
	    			*p++ = 0x02;
     			    p += buf_printf(p,"%08X",tmp);
			     *p++ = 0x03;
			     len = p-buf;
				USB_WriteEP(CDC_DEP_IN, (unsigned char*)buf, len);
		     }

		}

    }
}

//#define STX '['
//#define ETX ']'

#define STX 0x02
#define ETX 0x03


#define RBUF_LEN  20



void on_usb_data(char *buf, int len)
{
static char rbuf[RBUF_LEN+1];
static int rcnt = 0;
int i;
	for(i=0;i<len;i++)
	{
	  switch(buf[i])
	  {
	      case STX:
	    	rcnt = 0;
		  break;

	      case ETX:
	    	rbuf[rcnt] = 0x00;
	        	if(rbuf[0]=='0')
        	       	lcd_puts(0,rbuf[1] & 0x0F, &rbuf[2]);
	        	else if(rbuf[0]=='1')
	        		lcd_puts(1,rbuf[1] & 0x0F, &rbuf[2]);
	        	else if(rbuf[0]=='2')
        	       	bits_processing(&rbuf[2]);
	      break;

	      default:
	      {
            if(rcnt<RBUF_LEN)
	    	rbuf[rcnt++] = buf[i];
	      }
	  }
	}
}







