#ifndef __UTILS_H__
#define __UTILS_H__

#define EOF (-1)

typedef struct
{
  int push_indx;
  int pop_indx;
  unsigned long *buffer;
  int size;
} FIFO;

int buf_printf ( char *buf,
	const char* str,	/* Pointer to the format string */
	...					/* Optional arguments... */
);

int fifo_push(FIFO *fifo, unsigned long data);
int fifo_pop(FIFO *fifo, unsigned long *data);
void init_fifo(FIFO *fifo, int items_number);
unsigned long hex2ulong(const char *in);


#endif
